=== debian/changelog ===
rpma (1.0.0-1) unstable; urgency=medium

  * The "it's perfect now!" upstream release.
  * Symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 25 Aug 2022 13:10:06 +0200

rpma (0.14.0-1) experimental; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 16 Mar 2022 16:26:04 +0100

rpma (0.13.0-1) experimental; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 16 Mar 2022 16:11:45 +0100

rpma (0.12.0-1) experimental; urgency=medium

  * New upstream release.
  * Reenable +fortify.
  * B-Depend on valgrind-if-available.
  * Drop the symbols file for now.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 22 Feb 2022 14:26:02 +0100

rpma (0.11.0-1) experimental; urgency=medium

  * New upstream release.
  * Replace symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 11 Feb 2022 09:39:12 +0100

rpma (0.10.0-1) experimental; urgency=medium

  * New upstream release.
  * Disable RoCE tests.
  * Add new B-Deps.
  * Enable riscv64.
  * Add a watch file.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 26 Jan 2022 08:49:33 +0100

rpma (0.9.0-1) experimental; urgency=medium

  * Initial release (Closes: #971512)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 21 Oct 2020 06:23:36 +0200
