## rpma 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #
 # SPDX-License-Identifier: BSD-3-Clause
-# Copyright 2020-2022, Intel Corporation
+# Copyright 2020-2023, Intel Corporation
+# Copyright (c) 2022 Fujitsu Limited
 #
 
 cmake_minimum_required(VERSION 3.3)
@@ -8,7 +9,7 @@
 project(rpma C)
 
 set(VERSION_MAJOR 1)
-set(VERSION_MINOR 0)
+set(VERSION_MINOR 2)
 set(VERSION_PATCH 0)
 # set(VERSION_PRERELEASE rc1)
 
@@ -41,7 +42,6 @@
 
 option(TESTS_COVERAGE "run coverage test" OFF)
 option(TESTS_NO_FORTIFY_SOURCE "enable tests that do not pass when -D_FORTIFY_SOURCE=2 flag set" OFF)
-option(TESTS_PERF_TOOLS "run tests for the performance analysis tools" OFF)
 option(TESTS_RDMA_CONNECTION "enable tests that require a configured RDMA-capable network interface (valgrind required)" OFF)
 option(TESTS_USE_FORCED_PMEM "run tests with PMEM_IS_PMEM_FORCE=1" OFF)
 option(TESTS_USE_VALGRIND_PMEMCHECK "enable tests with valgrind pmemcheck (if found)" OFF)
@@ -179,6 +179,15 @@
 	message(WARNING "atomic operations are NOT supported (too old gcc/clang compiler). Some *_set*() functions will NOT be thread-safe!")
 endif()
 
+# check if libibverbs has ibv_wr_atomic_write() support
+is_ibv_wr_atomic_write_supported(IBV_WR_ATOMIC_WRITE_SUPPORTED)
+if(IBV_WR_ATOMIC_WRITE_SUPPORTED)
+	message(STATUS "ibv_wr_atomic_write() supported in libibverbs - Success")
+	add_flag(-DIBV_WR_ATOMIC_WRITE_SUPPORTED=1)
+else()
+	message(WARNING "ibv_wr_atomic_write() is NOT supported and will be disabled (too old version of libibverbs)!")
+endif()
+
 add_custom_target(checkers ALL)
 add_custom_target(cstyle)
 add_custom_target(check-whitespace)
@@ -312,11 +321,6 @@
 	add_subdirectory(examples)
 endif()
 
-if(TESTS_PERF_TOOLS)
-	find_package(PYLINT REQUIRED pylint)
-	add_subdirectory(tools/perf)
-endif()
-
 if(NOT "${CPACK_GENERATOR}" STREQUAL "")
 	include(${CMAKE_SOURCE_DIR}/cmake/packages.cmake)
 endif()
