=== examples/09-flush-to-persistent-GPSPM/CMakeLists.txt ===
--- 
+++ 
@@ -45,5 +45,5 @@
 
 link_directories(${LIBRPMA_LIBRARY_DIRS})
 
-add_example_with_pmem(NAME server USE_LIBPROTOBUFC SRCS server.c GPSPM_flush.pb-c.c)
-add_example_with_pmem(NAME client USE_LIBPROTOBUFC SRCS client.c GPSPM_flush.pb-c.c)
+add_example_with_pmem(NAME server USE_LIBPROTOBUFC SRCS server.c ../common/gpspm/GPSPM_flush.pb-c.c)
+add_example_with_pmem(NAME client USE_LIBPROTOBUFC SRCS client.c ../common/gpspm/GPSPM_flush.pb-c.c ../common/common-utils.c)
