=== debian/changelog ===
rpma (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Change architecture to "any".

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 10 Jan 2023 12:08:29 +0100

rpma (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Undisable libunwind on riscv64.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 09 Jan 2023 15:12:28 +0100

rpma (1.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 08 Sep 2022 10:24:59 +0200
